/* compatibility header file */

#include "chelpers.h"

/* SuSE 10.1 Linux does not know trunc */
#ifndef trunc
#  define trunc(x)  ( ((x)>0) ? floor((x)) : ceil((x)) )
#endif

/* Sparc Solaris GCC 3.4.6 does not know ISO C99's `isfinite` */
#ifndef isfinite
#  define isfinite tools_isfinite
#endif

/* needed to compile under Solaris; orig in MinGW: 0x8000 */
#if !defined(_WIN32) && !defined(LUA_DOS) && !defined(__OS2__)
#define O_BINARY      0x0000
#endif

/* determine the maximum of two numbers (in Linux, fmax is missing) */
#ifndef fmax
#  define fmax(a, b)  (a > b) ? a : b  /* substitute for Linux */
#endif

/* define constant `undefined` */
#ifdef NAN
#define AGN_NAN NAN
#elif defined(INFINITY)
#define AGN_NAN (INFINITY/INFINITY)
#else
#define AGN_NAN (tools_nan())
#endif

/* define complex unit I, which natively is not known to Solaris */
#ifdef __unix__
#undef _Complex_I
#define _Complex_I   (0.0F + 1.0iF)
#undef I
#define I   _Complex_I
#endif

