/*
** $Id: lcomplex.h v 0.1, based on ltable.h v2.10 2006/01/10 13:13:06 roberto Exp $
** Agena Complex Numbers
** See Copyright Notice in lua.h
*/

#ifndef lcomplex_h
#define lcomplex_h

#include "lobject.h"

#ifndef LUA_ANSI
#include "agnconf.h"  /* for definition of I */
#include <complex.h>
#define complexreal(t)     (creal((t)->c))
#define compleximag(t)     (cimag((t)->c))
#else
#define complexreal(t)     ((t)->re)
#define compleximag(t)     ((t)->im)
#endif

#ifndef LUA_ANSI
LUAI_FUNC Complex *agnCmplx_create (lua_State *L, agn_Complex c);
#else
LUAI_FUNC Complex *agnCmplx_create (lua_State *L, lua_Number re, lua_Number im);
#endif
LUAI_FUNC Complex *agnCmplx_make (lua_State *L, const TValue *re, const TValue *im);
LUAI_FUNC void agnCmplx_free (lua_State *L, Complex *t);

#endif

